local options = {}
local f = CreateFrame("frame")
local L = MpkaAnnounce_Locales


local config = CreateFrame("Frame")
local configOpenRunOnce = false
local keystone = nil
local table1 = nil
local communitys = {}
local communitysLine = {}
local TempName = nil
local TempID = nil
local TempName2 = nil
local TempID2 = nil
local SpamCooldown = nil

local function getClubs()
	table1 = C_Club.GetSubscribedClubs(); 
	for in1, da1 in ipairs(table1) do 
		for key, value in pairs(da1) do 		
			if key == "name" then
				TempName = value
			end
			if key == "clubId" then
				TempID = value
			end			
		end
		
		local TEMPTABLE = C_Club.GetStreams(TempID)
		
		for in2, da2 in ipairs(TEMPTABLE) do
			for key, value in pairs(da2) do 			
				if key == "name" then
					TempName2 = value
				end
				if key == "streamId" then
					TempID2 = value
				end				
			end	
			
			communitysLine = string.format("%s-%s|%s:%s", TempName, TempName2, TempID, TempID2)			
			table.insert(communitys, communitysLine)
			
		end
	end
end

local function SetFocus(ClubStreamID)
	local t1 = nil
	local First = nil
	local Second = nil
	
	if ClubStreamID == "ALL" then	
		if table.getn(communitys) == 0 then
			getClubs()
		end		
		for comIndex, comData in ipairs(communitys) do 
			First, Second = comData:match("([^,]+)|([^,]+)")
			clubID, StreamID = Second:match("([^,]+):([^,]+)")	
			t1 = C_Club.FocusStream(clubID, StreamID)
		end
	else
		First, Second = ClubStreamID:match("([^,]+):([^,]+)")	
		t1 = C_Club.FocusStream(First, Second)
	end
end



local function keypost(force, guild, community, streamid)
	local fullName, realm = UnitFullName("player")
	keystone = nil -- reset Keystone
	for bag = 0, NUM_BAG_SLOTS do
        local numSlots = GetContainerNumSlots(bag)
        for slot = 1, numSlots do
            if (GetContainerItemID(bag, slot) == 158923) then
                local link = GetContainerItemLink(bag, slot)		
				if force or (keystone and keystone ~= link) then
                    local message = string.format("%s-%s: %s", fullName, realm, link)	
					if (community ~= nil) and (streamid ~= nil) then	
						C_Club.SendMessage(community, streamid, message);
						return
					end	
					
					if guild then
                        SendChatMessage(link, "GUILD")
                    else
                        SendChatMessage(link, "PARTY")
                    end                    
                end
                keystone = link
                return
            end
        end
    end
end

local function registerEvents()
	if options.enabled then
		if options.inGuild then
			f:RegisterEvent("CHAT_MSG_GUILD")
		else
			f:UnregisterEvent("CHAT_MSG_GUILD")
		end
		
		if options.inCommunity then
			f:RegisterEvent("CLUB_MESSAGE_ADDED")
		else
			f:UnregisterEvent("CLUB_MESSAGE_ADDED")
		end
		
		--local inInstance, instanceType = IsInInstance()		
		--local isInstanceGroup = IsInGroup(LE_PARTY_CATEGORY_INSTANCE)
		--local isPartyGroup = IsInGroup()		
		
		if options.inParty then
			f:RegisterEvent("CHAT_MSG_PARTY")
			f:RegisterEvent("CHAT_MSG_PARTY_LEADER")
		else
			f:UnregisterEvent("CHAT_MSG_PARTY")
			f:UnregisterEvent("CHAT_MSG_PARTY_LEADER")
		end
	else
		f:UnregisterEvent("CHAT_MSG_GUILD")
		f:UnregisterEvent("CHAT_MSG_PARTY")
		f:UnregisterEvent("CHAT_MSG_PARTY_LEADER")
		f:UnregisterEvent("CLUB_MESSAGE_ADDED")
	end
end
	

local function getBoolean(val)
	if val then
		return true
	else
		return false
	end
end

local function setupMPKConfig(c)
	if configOpenRunOnce then
		return
	end

	configOpenRunOnce = true

	config.name = "M+ Key Announce"

	config.title = config:CreateFontString("MPKconfigTitleFont", "ARTWORK", "GameFontNormal")
	config.title:SetFont(GameFontNormal:GetFont(), 16, "OUTLINE")
	config.title:SetPoint("TOPLEFT", config, 10, -10)
	config.title:SetText(config.name)

	config.enablebox = CreateFrame("CheckButton", "MPKenableButton", config, "InterfaceOptionsCheckButtonTemplate")
	config.enablebox:SetPoint("TOPLEFT", config, 10, -28)
	config.enablebox:SetChecked(options.enabled)
	config.enablebox:SetHitRectInsets(0, -200, 0, 0)
	config.enableboxtitle = config:CreateFontString("MPKconfigEnableboxFont", "ARTWORK", "GameFontNormal")
	config.enableboxtitle:SetFont(GameFontNormal:GetFont(), 12, "OUTLINE")
	config.enableboxtitle:SetPoint("LEFT", config.enablebox, 30, 0)
	config.enableboxtitle:SetText("|cffffffff" .. L.enable_addon .. "|r")

	config.partybox = CreateFrame("CheckButton", "MPKpartyButton", config, "InterfaceOptionsCheckButtonTemplate")
	config.partybox:SetPoint("TOPLEFT", config, 10, -48)
	config.partybox:SetChecked(options.inParty)
	config.partybox:SetHitRectInsets(0, -200, 0, 0)
	config.partyboxtitle = config:CreateFontString("MPKconfigpartyboxFont", "ARTWORK", "GameFontNormal")
	config.partyboxtitle:SetFont(GameFontNormal:GetFont(), 12, "OUTLINE")
	config.partyboxtitle:SetPoint("LEFT", config.partybox, 30, 0)
	config.partyboxtitle:SetText("|cffffffff" .. L.active_party .. "|r")

	config.guildbox = CreateFrame("CheckButton", "MPKguildButton", config, "InterfaceOptionsCheckButtonTemplate")
	config.guildbox:SetPoint("TOPLEFT", config, 10, -68)
	config.guildbox:SetChecked(options.inGuild)
	config.guildbox:SetHitRectInsets(0, -200, 0, 0)
	config.guildboxtitle = config:CreateFontString("MPKconfigoutdoorboxFont", "ARTWORK", "GameFontNormal")
	config.guildboxtitle:SetFont(GameFontNormal:GetFont(), 12, "OUTLINE")
	config.guildboxtitle:SetPoint("LEFT", config.guildbox, 30, 0)
	config.guildboxtitle:SetText("|cffffffff" .. L.active_guild .. "|r")
	
	config.cdboxtitle = config:CreateFontString("MPKconfigoutputtitleFont", "ARTWORK", "GameFontNormal")
	config.cdboxtitle:SetFont(GameFontNormal:GetFont(), 12, "OUTLINE")
	config.cdboxtitle:SetPoint("TOPLEFT", config, 10, -96)
	config.cdboxtitle:SetText("|cffffffff" .. "Spam CoolDown: " .. "|r")

	config.cdbox = CreateFrame("EditBox", "MPKoutputbox", config, "InputBoxTemplate")
	config.cdbox:SetPoint("TOPLEFT", config, 130, -92)
	config.cdbox:SetSize(20, 20)
	config.cdbox:SetAutoFocus(false)
	config.cdbox:SetMultiLine(false)
	config.cdbox:SetText(options.SpamCdTime)
	config.cdbox:SetCursorPosition(0)
	config.cdbox:SetScript("OnEnterPressed", function(self) self:ClearFocus() end)
	
	config.cdboxtitleEnd = config:CreateFontString("MPKconfigoutputtitleFontEnd", "ARTWORK", "GameFontNormal")
	config.cdboxtitleEnd:SetFont(GameFontNormal:GetFont(), 12, "OUTLINE")
	config.cdboxtitleEnd:SetPoint("TOPLEFT", config, 150, -96)
	config.cdboxtitleEnd:SetText("|cffffffff" .. "seconds" .. "|r")
	
	
	
	
	
	config.communitybox = CreateFrame("CheckButton", "MPKCommunityButton", config, "InterfaceOptionsCheckButtonTemplate")
	config.communitybox:SetPoint("TOPLEFT", config, 10, -108)
	config.communitybox:SetChecked(options.inCommunity)
	config.communitybox:SetHitRectInsets(0, -200, 0, 0)
	config.communityboxtitle  = config:CreateFontString("MPKconfigcommunityboxFont", "ARTWORK", "GameFontNormal")
	config.communityboxtitle :SetFont(GameFontNormal:GetFont(), 12, "OUTLINE")
	config.communityboxtitle :SetPoint("LEFT", config.communitybox, 30, 0)
	config.communityboxtitle :SetText("|cffffffff" .. L.active_community .. "|r")
	
	

	dropDown = CreateFrame("Button", "MPKchannelDropdown", config, "UIDropDownMenuTemplate")
	dropDown:SetPoint("TOPLEFT", config, 10, -128)
	UIDropDownMenu_SetWidth(dropDown, 200)
	UIDropDownMenu_SetText(dropDown, mpkAnnounce.channelname)
	
	UIDropDownMenu_Initialize(dropDown, function(self, level, menuList)
	local info = UIDropDownMenu_CreateInfo()
	
	info.text, info.arg1, info.arg2, info.checked = L.AllCommunity, L.AllCommunity, "ALL", false
	info.func = self.SetValue
	UIDropDownMenu_AddButton(info, level)
	
	
		if table.getn(communitys) == 0 then
			getClubs()
		end
	
		for in2, da2 in ipairs(communitys) do 
			one, two = da2:match("([^,]+)|([^,]+)")	
			info.func = self.SetValue
			info.text, info.arg1, info.arg2, info.checked = one, one, two, false
			UIDropDownMenu_AddButton(info, level)
			UIDropDownMenu_SetSelectedName(dropDown, mpkAnnounce.channelname, true) 
		end
	end
	
	
	
	)


	function dropDown:SetValue(...)
	text, arg1, arg2, checked = ...
	mpkAnnounce.channelname = text
	mpkAnnounce.channelid = arg1
	UIDropDownMenu_SetText(dropDown, text)
	CloseDropDownMenus()
	end
	config.okay = function(self)
		mpkAnnounce.enabled = getBoolean(config.enablebox:GetChecked())
		mpkAnnounce.inParty = getBoolean(config.partybox:GetChecked())
		mpkAnnounce.inGuild = getBoolean(config.guildbox:GetChecked())
		mpkAnnounce.inCommunity = getBoolean(config.communitybox:GetChecked())
		mpkAnnounce.inCommunity = getBoolean(config.communitybox:GetChecked())	
		mpkAnnounce.SpamCdTime = config.cdbox:GetText()		
		
		if mpkAnnounce.inCommunity == true then
			mpkAnnounce.channelname = options.channelname
			mpkAnnounce.channelid = options.channelid
		else
			mpkAnnounce.channelname = nil
			mpkAnnounce.channelid = nil
			UIDropDownMenu_SetText(dropDown, mpkAnnounce.channelname)
		end

		options = mpkAnnounce
		

		
		registerEvents()
		SetFocus(options.channelid)
		
		
		
		
		if mpkAnnounce.inCommunity == true and (mpkAnnounce.channelname == nil or mpkAnnounce.channelname == "") then
			print("|cffff0000" .. L.Community_Error .. "|r")
		end		
	end

	config.cancel = function(self)
		config.enablebox:SetChecked(options.enabled)	
		config.partybox:SetChecked(options.inParty)
		config.guildbox:SetChecked(options.inGuild)
		config.communitybox:SetChecked(options.inCommunity)
		config.channelname = options.channelname
		config.channelid = options.channelid
		config.outputbox:SetText(options.SpamCdTime)
		
	end

	InterfaceOptions_AddCategory(config)

end


f:SetScript("OnEvent", function(self, event, ...)
    self[event](self, ...)
end)

function f:CHAT_MSG_GUILD(...)
	local TimeGuild = GetTime()
	local NewTimeGuild = TimeGuild+tonumber(options.SpamCdTime)

	if select(1, ...) == "!mpk" or select(1, ...) == "!keys" then
			if tonumber(options.lastCooldownGuild) < TimeGuild then
				keypost(true,true,nil,nil)
				options.lastCooldownGuild = NewTimeGuild
			end
    end	
end

function f:CHAT_MSG_PARTY(...)
	local TimeParty = GetTime()
	local NewTimeParty = TimeParty+tonumber(options.SpamCdTime)
	if select(1, ...) == "!mpk" or select(1, ...) == "!keys" then
		if tonumber(options.lastCooldownParty) < TimeParty then
			keypost(true, nil, nil, nil)
			options.lastCooldownParty = NewTimeParty
		end
    end	
end

function f:CHAT_MSG_PARTY_LEADER(...)
	local TimeParty = GetTime()
	local NewTimeParty = TimeParty+tonumber(options.SpamCdTime)
	if select(1, ...) == "!mpk" or select(1, ...) == "!keys" then
		if tonumber(options.lastCooldownParty) < TimeParty then
			keypost(true, nil, nil, nil)
			options.lastCooldownParty = NewTimeParty
		end
    end	
end

function f:CLUB_MESSAGE_ADDED(...)
	local clubId, streamId, messageId = ...
	local GuildClubID = C_Club.GetGuildClubId()
	local Time = GetTime()
	local NewTime = Time+tonumber(options.SpamCdTime)
	local Info = C_Club.GetMessageInfo(clubId, streamId, messageId)
	
	if tostring(clubId) ~= tostring(GuildClubID) then
		if tonumber(options.lastCooldownCommunity) < Time then
			if mpkAnnounce.channelid ~= "ALL" then
			
				local one1, two1 = options.channelid:match("([^,]+):([^,]+)")
				--SetFocus(mpkAnnounce.channelid) -- Temp disabled
				if tostring(clubId) == tostring(one1) then
					if tostring(streamId) == tostring(two1) then
						if Info.content == "!mpk" or Info.content == "!keys" then
							keypost(true, nil, clubId, streamId)
							options.lastCooldownCommunity = NewTime
						end
					end
				end
			else
				if Info.content == "!mpk" or Info.content == "!keys" then
					keypost(true, nil, clubId, streamId)
					options.lastCooldownCommunity = NewTime
				end
			end
		end
	else
		return
	end	
	
end





function f:INITIAL_CLUBS_LOADED(...)	
	SetFocus(options.channelid)
end

function f:PLAYER_ENTERING_WORLD()
	registerEvents()
end




function f:PLAYER_LOGIN()
	setupMPKConfig()
	options.lastCooldownCommunity = "0"
	options.lastCooldownParty = "0"
	options.lastCooldownGuild = "0"
end

function f:ADDON_LOADED(addon)
	if addon ~= "MpkeyAnnounce" then return end

    local defaults = {
		enabled = true,
		inGuild = true,
		inParty = true,
		inCommunity = false,
		channelname = "",
		channelid = "",
		lastCooldownCommunity = 0,
		lastCooldownParty = 0,
		lastCooldownGuild = 0,
		SpamCdTime = 30,
	}

	mpkAnnounce = mpkAnnounce or {}

	for k,v in pairs(defaults) do
		if mpkAnnounce[k] == nil then
			mpkAnnounce[k] = v
		end
	end

	options = mpkAnnounce

	-- This is where config setup used to be


	SLASH_MPKANNOUNCE1 = "/mpka"
	SlashCmdList.MPKANNOUNCE = function(msg)
		InterfaceOptionsFrame_Show()
		InterfaceOptionsFrame_OpenToCategory(config)
	end



	f:RegisterEvent("PLAYER_LOGIN")
	f:RegisterEvent("PLAYER_ENTERING_WORLD")
	registerEvents()

	f:RegisterEvent("INITIAL_CLUBS_LOADED")
end

f:RegisterEvent("ADDON_LOADED")








